diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/spectrum/model/three-gpp-channel-model.h ns-3.34/src/spectrum/model/three-gpp-channel-model.h
--- ns-3.33/src/spectrum/model/three-gpp-channel-model.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/spectrum/model/three-gpp-channel-model.h	2021-07-14 10:31:07.000000000 -0700
@@ -117,8 +117,8 @@
    */
   Ptr<const ChannelMatrix> GetChannel (Ptr<const MobilityModel> aMob,
                                        Ptr<const MobilityModel> bMob,
-                                       Ptr<const ThreeGppAntennaArrayModel> aAntenna,
-                                       Ptr<const ThreeGppAntennaArrayModel> bAntenna) override;
+                                       Ptr<const PhasedArrayModel> aAntenna,
+                                       Ptr<const PhasedArrayModel> bAntenna) override;
   /**
    * \brief Assign a fixed random variable stream number to the random variables
    * used by this model.
@@ -130,6 +130,20 @@
   
 private:
   /**
+   * Wrap an (azimuth, inclination) angle pair in a valid range.
+   * Specifically, inclination must be in [0, M_PI] and azimuth in [0, 2*M_PI).
+   * If the inclination angle is outside of its range, the azimuth angle is
+   * rotated by M_PI.
+   * This methods aims specifically at solving the problem of generating angles at
+   * the boundaries of the angle domain, specifically, generating angle distributions
+   * close to inclinationRad=0 and inclinationRad=M_PI.
+   *
+   * \param azimuthRad the azimuth angle in radians
+   * \param inclinationRad the inclination angle in radians
+   * \return the wrapped (azimuth, inclination) angle pair in radians
+   */
+  static std::pair<double, double> WrapAngles (double azimuthRad, double inclinationRad);
+  /**
    * \brief Shuffle the elements of a simple sequence container of type double
    * \param first Pointer to the first element among the elements to be shuffled
    * \param last Pointer to the last element among the elements to be shuffled
@@ -217,8 +231,8 @@
    * \return the channel realization
    */
   Ptr<ThreeGppChannelMatrix> GetNewChannel (Vector locUT, Ptr<const ChannelCondition> channelCondition,
-                                            Ptr<const ThreeGppAntennaArrayModel> sAntenna,
-                                            Ptr<const ThreeGppAntennaArrayModel> uAntenna,
+                                            Ptr<const PhasedArrayModel> sAntenna,
+                                            Ptr<const PhasedArrayModel> uAntenna,
                                             Angles &uAngle, Angles &sAngle,
                                             double dis2D, double hBS, double hUT) const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc ns-3.34/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc
--- ns-3.33/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2021-07-14 10:31:07.000000000 -0700
@@ -23,7 +23,7 @@
 #include "ns3/log.h"
 #include "three-gpp-spectrum-propagation-loss-model.h"
 #include "ns3/net-device.h"
-#include "ns3/three-gpp-antenna-array-model.h"
+#include "ns3/phased-array-model.h"
 #include "ns3/node.h"
 #include "ns3/channel-condition-model.h"
 #include "ns3/double.h"
@@ -95,7 +95,7 @@
 }
 
 void
-ThreeGppSpectrumPropagationLossModel::AddDevice (Ptr<NetDevice> n, Ptr<const ThreeGppAntennaArrayModel> a)
+ThreeGppSpectrumPropagationLossModel::AddDevice (Ptr<NetDevice> n, Ptr<const PhasedArrayModel> a)
 {
   NS_ASSERT_MSG (m_deviceAntennaMap.find (n->GetNode ()->GetId ()) == m_deviceAntennaMap.end (), "Device is already present in the map");
   m_deviceAntennaMap.insert (std::make_pair (n->GetNode ()->GetId (), a));
@@ -121,10 +121,10 @@
   m_channelModel->GetAttribute (name, value);
 }
 
-ThreeGppAntennaArrayModel::ComplexVector
+PhasedArrayModel::ComplexVector
 ThreeGppSpectrumPropagationLossModel::CalcLongTerm (Ptr<const MatrixBasedChannelModel::ChannelMatrix> params,
-                                                    const ThreeGppAntennaArrayModel::ComplexVector &sW,
-                                                    const ThreeGppAntennaArrayModel::ComplexVector &uW) const
+                                                    const PhasedArrayModel::ComplexVector &sW,
+                                                    const PhasedArrayModel::ComplexVector &uW) const
 {
   NS_LOG_FUNCTION (this);
 
@@ -134,7 +134,7 @@
   NS_LOG_DEBUG ("CalcLongTerm with sAntenna " << sAntenna << " uAntenna " << uAntenna);
   //store the long term part to reduce computation load
   //only the small scale fading needs to be updated if the large scale parameters and antenna weights remain unchanged.
-  ThreeGppAntennaArrayModel::ComplexVector longTerm;
+  PhasedArrayModel::ComplexVector longTerm;
   uint8_t numCluster = static_cast<uint8_t> (params->m_channel[0][0].size ());
 
   for (uint8_t cIndex = 0; cIndex < numCluster; cIndex++)
@@ -156,7 +156,7 @@
 
 Ptr<SpectrumValue>
 ThreeGppSpectrumPropagationLossModel::CalcBeamformingGain (Ptr<SpectrumValue> txPsd,
-                                                           ThreeGppAntennaArrayModel::ComplexVector longTerm,
+                                                           PhasedArrayModel::ComplexVector longTerm,
                                                            Ptr<const MatrixBasedChannelModel::ChannelMatrix> params,
                                                            const ns3::Vector &sSpeed, const ns3::Vector &uSpeed) const
 {
@@ -171,7 +171,7 @@
   // NOTE the update of Doppler is simplified by only taking the center angle of
   // each cluster in to consideration.
   double slotTime = Simulator::Now ().GetSeconds ();
-  ThreeGppAntennaArrayModel::ComplexVector doppler;
+  PhasedArrayModel::ComplexVector doppler;
   for (uint8_t cIndex = 0; cIndex < numCluster; cIndex++)
     {
       // Compute alpha and D as described in 3GPP TR 37.885 v15.3.0, Sec. 6.2.3
@@ -226,17 +226,17 @@
   return tempPsd;
 }
 
-ThreeGppAntennaArrayModel::ComplexVector
+PhasedArrayModel::ComplexVector
 ThreeGppSpectrumPropagationLossModel::GetLongTerm (uint32_t aId, uint32_t bId,
                                                    Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
-                                                   const ThreeGppAntennaArrayModel::ComplexVector &aW,
-                                                   const ThreeGppAntennaArrayModel::ComplexVector &bW) const
+                                                   const PhasedArrayModel::ComplexVector &aW,
+                                                   const PhasedArrayModel::ComplexVector &bW) const
 {
-  ThreeGppAntennaArrayModel::ComplexVector longTerm; // vector containing the long term component for each cluster
+  PhasedArrayModel::ComplexVector longTerm; // vector containing the long term component for each cluster
 
   // check if the channel matrix was generated considering a as the s-node and
   // b as the u-node or viceversa
-  ThreeGppAntennaArrayModel::ComplexVector sW, uW;
+  PhasedArrayModel::ComplexVector sW, uW;
   if (!channelMatrix->IsReverse (aId, bId))
   {
     sW = aW;
@@ -311,28 +311,22 @@
 
   // retrieve the antenna of device a
   NS_ASSERT_MSG (m_deviceAntennaMap.find (aId) != m_deviceAntennaMap.end (), "Antenna not found for node " << aId);
-  Ptr<const ThreeGppAntennaArrayModel> aAntenna = m_deviceAntennaMap.at (aId);
+  Ptr<const PhasedArrayModel> aAntenna = m_deviceAntennaMap.at (aId);
   NS_LOG_DEBUG ("a node " << a->GetObject<Node> () << " antenna " << aAntenna);
 
   // retrieve the antenna of the device b
   NS_ASSERT_MSG (m_deviceAntennaMap.find (bId) != m_deviceAntennaMap.end (), "Antenna not found for device " << bId);
-  Ptr<const ThreeGppAntennaArrayModel> bAntenna = m_deviceAntennaMap.at (bId);
+  Ptr<const PhasedArrayModel> bAntenna = m_deviceAntennaMap.at (bId);
   NS_LOG_DEBUG ("b node " << bId << " antenna " << bAntenna);
 
-  if (aAntenna->IsOmniTx () || bAntenna->IsOmniTx () )
-    {
-      NS_LOG_LOGIC ("Omni transmission, do nothing.");
-      return rxPsd;
-    }
-
   Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix = m_channelModel->GetChannel (a, b, aAntenna, bAntenna);
 
   // get the precoding and combining vectors
-  ThreeGppAntennaArrayModel::ComplexVector aW = aAntenna->GetBeamformingVector ();
-  ThreeGppAntennaArrayModel::ComplexVector bW = bAntenna->GetBeamformingVector ();
+  PhasedArrayModel::ComplexVector aW = aAntenna->GetBeamformingVector ();
+  PhasedArrayModel::ComplexVector bW = bAntenna->GetBeamformingVector ();
 
   // retrieve the long term component
-  ThreeGppAntennaArrayModel::ComplexVector longTerm = GetLongTerm (aId, bId, channelMatrix, aW, bW);
+  PhasedArrayModel::ComplexVector longTerm = GetLongTerm (aId, bId, channelMatrix, aW, bW);
 
   // apply the beamforming gain
   rxPsd = CalcBeamformingGain (rxPsd, longTerm, channelMatrix, a->GetVelocity (), b->GetVelocity ());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h ns-3.34/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h
--- ns-3.33/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2021-07-14 10:31:07.000000000 -0700
@@ -46,7 +46,7 @@
  * returns the PSD of the received signal.
  *
  * \see MatrixBasedChannelModel
- * \see ThreeGppAntennaArrayModel
+ * \see PhasedArrayModel
  * \see ChannelCondition
  */
 class ThreeGppSpectrumPropagationLossModel : public SpectrumPropagationLossModel
@@ -85,9 +85,9 @@
   /**
    * Add a device-antenna pair
    * \param n a pointer to the NetDevice
-   * \param a a pointer to the associated ThreeGppAntennaArrayModel
+   * \param a a pointer to the associated PhasedArrayModel
    */
-  void AddDevice (Ptr<NetDevice> n, Ptr<const ThreeGppAntennaArrayModel> a);
+  void AddDevice (Ptr<NetDevice> n, Ptr<const PhasedArrayModel> a);
 
 
   /**
@@ -136,10 +136,10 @@
    */
   struct LongTerm : public SimpleRefCount<LongTerm>
   {
-    ThreeGppAntennaArrayModel::ComplexVector m_longTerm; //!< vector containing the long term component for each cluster
+    PhasedArrayModel::ComplexVector m_longTerm; //!< vector containing the long term component for each cluster
     Ptr<const MatrixBasedChannelModel::ChannelMatrix> m_channel; //!< pointer to the channel matrix used to compute the long term
-    ThreeGppAntennaArrayModel::ComplexVector m_sW; //!< the beamforming vector for the node s used to compute the long term
-    ThreeGppAntennaArrayModel::ComplexVector m_uW; //!< the beamforming vector for the node u used to compute the long term
+    PhasedArrayModel::ComplexVector m_sW; //!< the beamforming vector for the node s used to compute the long term
+    PhasedArrayModel::ComplexVector m_uW; //!< the beamforming vector for the node u used to compute the long term
   };
 
   /**
@@ -159,10 +159,10 @@
    * \param bW the beamforming vector of the second device
    * \return vector containing the long term compoenent for each cluster
    */
-  ThreeGppAntennaArrayModel::ComplexVector GetLongTerm (uint32_t aId, uint32_t bId,
+  PhasedArrayModel::ComplexVector GetLongTerm (uint32_t aId, uint32_t bId,
                                                         Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
-                                                        const ThreeGppAntennaArrayModel::ComplexVector &aW,
-                                                        const ThreeGppAntennaArrayModel::ComplexVector &bW) const;
+                                                        const PhasedArrayModel::ComplexVector &aW,
+                                                        const PhasedArrayModel::ComplexVector &bW) const;
   /**
    * Computes the long term component
    * \param channelMatrix the channel matrix H
@@ -170,9 +170,9 @@
    * \param uW the beamforming vector of the u device
    * \return the long term component
    */
-  ThreeGppAntennaArrayModel::ComplexVector CalcLongTerm (Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
-                                                         const ThreeGppAntennaArrayModel::ComplexVector &sW,
-                                                         const ThreeGppAntennaArrayModel::ComplexVector &uW) const;
+  PhasedArrayModel::ComplexVector CalcLongTerm (Ptr<const MatrixBasedChannelModel::ChannelMatrix> channelMatrix,
+                                                         const PhasedArrayModel::ComplexVector &sW,
+                                                         const PhasedArrayModel::ComplexVector &uW) const;
 
   /**
    * Computes the beamforming gain and applies it to the tx PSD
@@ -184,11 +184,11 @@
    * \return the rx PSD
    */
   Ptr<SpectrumValue> CalcBeamformingGain (Ptr<SpectrumValue> txPsd,
-                                          ThreeGppAntennaArrayModel::ComplexVector longTerm,
+                                          PhasedArrayModel::ComplexVector longTerm,
                                           Ptr<const MatrixBasedChannelModel::ChannelMatrix> params,
                                           const Vector &sSpeed, const Vector &uSpeed) const;
 
-  std::unordered_map <uint32_t, Ptr<const ThreeGppAntennaArrayModel> > m_deviceAntennaMap; //!< map containig the <node, antenna> associations
+  std::unordered_map <uint32_t, Ptr<const PhasedArrayModel> > m_deviceAntennaMap; //!< map containig the <node, antenna> associations
   mutable std::unordered_map < uint32_t, Ptr<const LongTerm> > m_longTermMap; //!< map containing the long term components
   Ptr<MatrixBasedChannelModel> m_channelModel; //!< the model to generate the channel matrix
   
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/spectrum/model/tv-spectrum-transmitter.cc ns-3.34/src/spectrum/model/tv-spectrum-transmitter.cc
--- ns-3.33/src/spectrum/model/tv-spectrum-transmitter.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/spectrum/model/tv-spectrum-transmitter.cc	2021-07-14 10:31:07.000000000 -0700
@@ -144,7 +144,7 @@
 }
 
 Ptr<MobilityModel>
-TvSpectrumTransmitter::GetMobility ()
+TvSpectrumTransmitter::GetMobility () const
 {
   NS_LOG_FUNCTION (this);
   return m_mobility;
@@ -165,7 +165,7 @@
 }
 
 Ptr<AntennaModel>
-TvSpectrumTransmitter::GetRxAntenna ()
+TvSpectrumTransmitter::GetRxAntenna () const
 {
   NS_LOG_FUNCTION (this);
   return m_antenna;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/spectrum/model/tv-spectrum-transmitter.h ns-3.34/src/spectrum/model/tv-spectrum-transmitter.h
--- ns-3.33/src/spectrum/model/tv-spectrum-transmitter.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/spectrum/model/tv-spectrum-transmitter.h	2021-07-14 10:31:07.000000000 -0700
@@ -70,11 +70,11 @@
   void SetChannel (Ptr<SpectrumChannel> c);
   void SetMobility (Ptr<MobilityModel> m);
   void SetDevice (Ptr<NetDevice> d);
-  Ptr<MobilityModel> GetMobility ();
+  Ptr<MobilityModel> GetMobility () const;
   Ptr<NetDevice> GetDevice () const;
   // device does not use Rx but these pure virtual methods must be implemented
   Ptr<const SpectrumModel> GetRxSpectrumModel () const;
-  Ptr<AntennaModel> GetRxAntenna ();
+  Ptr<AntennaModel> GetRxAntenna () const;
   void StartRx (Ptr<SpectrumSignalParameters> params);
 
   /** 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/spectrum/model/waveform-generator.cc ns-3.34/src/spectrum/model/waveform-generator.cc
--- ns-3.33/src/spectrum/model/waveform-generator.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/spectrum/model/waveform-generator.cc	2021-07-14 10:31:07.000000000 -0700
@@ -105,7 +105,7 @@
 
 
 Ptr<MobilityModel>
-WaveformGenerator::GetMobility ()
+WaveformGenerator::GetMobility () const
 {
   return m_mobility;
 }
@@ -155,7 +155,7 @@
 }
 
 Ptr<AntennaModel>
-WaveformGenerator::GetRxAntenna ()
+WaveformGenerator::GetRxAntenna () const
 {
   return m_antenna;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/spectrum/model/waveform-generator.h ns-3.34/src/spectrum/model/waveform-generator.h
--- ns-3.33/src/spectrum/model/waveform-generator.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/spectrum/model/waveform-generator.h	2021-07-14 10:31:07.000000000 -0700
@@ -67,10 +67,10 @@
   void SetChannel (Ptr<SpectrumChannel> c);
   void SetMobility (Ptr<MobilityModel> m);
   void SetDevice (Ptr<NetDevice> d);
-  Ptr<MobilityModel> GetMobility ();
+  Ptr<MobilityModel> GetMobility () const;
   Ptr<NetDevice> GetDevice () const;
   Ptr<const SpectrumModel> GetRxSpectrumModel () const;
-  Ptr<AntennaModel> GetRxAntenna ();
+  Ptr<AntennaModel> GetRxAntenna () const;
   void StartRx (Ptr<SpectrumSignalParameters> params);
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/spectrum/model/wifi-spectrum-value-helper.cc ns-3.34/src/spectrum/model/wifi-spectrum-value-helper.cc
--- ns-3.33/src/spectrum/model/wifi-spectrum-value-helper.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/spectrum/model/wifi-spectrum-value-helper.cc	2021-07-14 10:31:07.000000000 -0700
@@ -422,6 +422,33 @@
 }
 
 Ptr<SpectrumValue>
+WifiSpectrumValueHelper::CreateHeMuOfdmTxPowerSpectralDensity (uint32_t centerFrequency, uint16_t channelWidth, double txPowerW, uint16_t guardBandwidth, WifiSpectrumBand ru)
+{
+  NS_LOG_FUNCTION (centerFrequency << channelWidth << txPowerW << guardBandwidth << ru.first << ru.second);
+  uint32_t bandBandwidth = 78125;
+  Ptr<SpectrumValue> c = Create<SpectrumValue> (GetSpectrumModel (centerFrequency, channelWidth, bandBandwidth, guardBandwidth));
+
+  //Build spectrum mask
+  Values::iterator vit = c->ValuesBegin ();
+  Bands::const_iterator bit = c->ConstBandsBegin ();
+  double txPowerPerBandW = (txPowerW / (ru.second - ru.first + 1)); //FIXME: null subcarriers
+  uint32_t numBands = c->GetSpectrumModel ()->GetNumBands ();
+  for (size_t i = 0; i < numBands; i++, vit++, bit++)
+    {
+      if (i < ru.first || i > ru.second) //outside the spectrum mask
+        {
+          *vit = 0.0;
+        }
+      else
+        {
+          *vit = (txPowerPerBandW / (bit->fh - bit->fl));
+        }
+    }
+  
+  return c;
+}
+
+Ptr<SpectrumValue>
 WifiSpectrumValueHelper::CreateNoisePowerSpectralDensity (uint32_t centerFrequency, uint16_t channelWidth, uint32_t bandBandwidth, double noiseFigure, uint16_t guardBandwidth)
 {
   Ptr<SpectrumModel> model = GetSpectrumModel (centerFrequency, channelWidth, bandBandwidth, guardBandwidth);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/spectrum/model/wifi-spectrum-value-helper.h ns-3.34/src/spectrum/model/wifi-spectrum-value-helper.h
--- ns-3.33/src/spectrum/model/wifi-spectrum-value-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/spectrum/model/wifi-spectrum-value-helper.h	2021-07-14 10:31:07.000000000 -0700
@@ -131,6 +131,20 @@
                                                                 double minInnerBandDbr = -20, double minOuterbandDbr = -28, double lowestPointDbr = -40);
 
   /**
+   * Create a transmit power spectral density corresponding to the OFDMA part
+   * of HE TB PPDUs for a given RU.
+   * An ideal (i.e. rectangular) spectral mask is considered for the time being.
+   *
+   * \param centerFrequency center frequency (MHz)
+   * \param channelWidth channel width (MHz)
+   * \param txPowerW  transmit power (W) to allocate
+   * \param guardBandwidth width of the guard band (MHz)
+   * \param ru the RU band used by the STA
+   * \return a pointer to a newly allocated SpectrumValue representing the HE OFDM Transmit Power Spectral Density on the RU used by the STA in W/Hz for each Band
+   */
+  static Ptr<SpectrumValue> CreateHeMuOfdmTxPowerSpectralDensity (uint32_t centerFrequency, uint16_t channelWidth, double txPowerW, uint16_t guardBandwidth, WifiSpectrumBand ru);
+
+  /**
    * Create a power spectral density corresponding to the noise
    *
    * \param centerFrequency center frequency (MHz)
